#include <owl\applicat.h>
#include <owl\framewin.h>
#include "pr48_1.rc"

// .
class TApp: public TApplication
{
  public:
	 TApp():TApplication() {}
	 void InitMainWindow();
};

//   .
class TWndw : public  TFrameWindow
{
  public:
    TWndw (TWindow *parent, const char far *title);
  protected:
    int  childX, childY;
    void CmOpen(); 
    void CmClose();

    DECLARE_RESPONSE_TABLE (TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
	EV_COMMAND (CM_OPEN, CmOpen),
	EV_COMMAND (CM_CLOSE, CmClose),
END_RESPONSE_TABLE;

//   .
class TChildWndw : public TWindow
{
  public:
    TChildWndw (TWindow *parent, const char far *title, 
         int xCoord, int yCoord);
  protected:
    char far *GetClassName();
    void GetWindowClass (WNDCLASS &wndClass);
};

// TWndw::TWndw()
//    .
TWndw::TWndw(TWindow *parent, const char far *title):
          TFrameWindow (parent, title) 
{
  //     .
  Attr.X = 20;
  Attr.Y = 20;
  Attr.W = 500;
  Attr.H = 400;
  //    . 
  AssignMenu(MENU_1);
  //     .
  childX = 75; 
  childY = 75;
} 

// TWndw::CmOpen()
//   ,  
//   Open   File.
//     .
void TWndw::CmOpen() 
{
  //    .
  TWindow *child = new TChildWndw (this, " ", childX, childY);
  //  . 
  child->Create();
  //    . 
  childX += 40; 
  if (childX > 400) childX = 75;
  childY += 40; 
  if (childY > 300) childX = 75;
}

// CloseTheWindow()
//  ForEach   ,  
//     .
void CloseTheWindow (TWindow *window, void*) 
{
  window->ShutDownWindow();
}

// TWndw::CmClose()
//      Close All  
// File,   ForEach    
//     TWndw. 
void TWndw::CmClose() 
{
  ForEach(CloseTheWindow);
}

//************************************
//   TChildWndw.
//************************************
// TChildWndw::TChildWndw()
//    .
TChildWndw::TChildWndw (TWindow  *parent,
     const char far *title, int xCoord,  int yCoord) :
            TWindow(parent, title) 
{
  //   .
  Attr.Style = WS_CHILD | WS_VISIBLE | WS_BORDER | 
      WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU | WS_CLIPSIBLINGS;
  //      .
  Attr.X = xCoord;
  Attr.Y = yCoord;
  Attr.W = 200;
  Attr.H = 150;
}

// TChildWndw::GetClassName()
//    GetClassName() 
// TWindow       .
char far *TChildWndw::GetClassName()
{
  return "ChildWindow";
}

// TChildWndw::GeTWindowClass()
//    GetWindowClass() 
//  ,   ,
//   ,    OWL.
void TChildWndw::GetWindowClass(WNDCLASS &wndClass)
{
  //  TWindow   .
  TWindow::GetWindowClass(wndClass);
  //     .
  wndClass.hCursor = LoadCursor(0, IDC_CROSS);
  //      .
  wndClass.hbrBackground = (HBRUSH) GetStockObject (LTGRAY_BRUSH);
  //     .
  TApplication  *instance = GetApplication();
  wndClass.hIcon = LoadIcon(*instance, "DOC_ICON");
}
 
void TApp::InitMainWindow()
{
  TFrameWindow *wndw = new TWndw (0,"   "); 
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
